#include <iostream>
#include <cstring>

using namespace std;

const int N = 2e5 + 1;
int n;

struct Graph {
    int ans[N];
    int par[N];
    int nxt[N];
    bool stk[N];
} g;

int calc(int u) {
    g.stk[u] = true;
    if (g.ans[u] != -1) {
        g.stk[u] = false;
        return g.ans[u];
    }
    int v = g.nxt[u];
    if (g.stk[v]) {
        int clen = 0;
        for (int w = u; ; w = g.par[w]) {
            clen++;
            if (w == v) break;
        }
        for (int w = u; ; w = g.par[w]) {
            g.ans[w] = clen;
            if (w == v) break;
        }
        g.stk[u] = false;
        return g.ans[u];
    }
    g.par[v] = u;
    int r = calc(v);

    if (g.ans[u] == -1) {
        g.ans[u] = r + 1;
    }
    g.stk[u] = false;
    return g.ans[u];
}

int main() {
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> g.nxt[i];
    }
    memset(g.ans, -1, sizeof g.ans);
    int ans = 0, opt = 0;
    for (int i = 1; i <= n; ++i) {
        int res = calc(i);
        if (opt < res) {
            opt = res;
            ans = i;
        }
    }
    cout << ans << " " << opt << "\n";
}
