program hirlanc;

uses
  SysUtils;

const
  MAXN = 200001;

var
  N, i, u, v, len, j, cur, nxt, K: longInt;
  C, vis, id, cnt, q: array[1..MAXN] of longInt;

begin
  ReadLn(N);
  for i := 1 to N do
    Read(C[i]);

  for i := 1 to N do
  begin
    vis[i] := 0;
    id[i] := 0;
    cnt[i] := 0;
  end;

  for u := 1 to N do
  begin
    if vis[u] > 0 then
      Continue;

    i := 1;
    v := u;
    while vis[v] = 0 do
    begin
      vis[v] := u;
      id[v] := i;
      q[i] := v;
      Inc(i);
      v := C[v];
    end;

    if vis[v] = u then
    begin
      len := i - id[v];
      for j := id[v] to i - 1 do
        cnt[q[j]] := len;
    end
    else
    begin
      q[i] := v;
      id[v] := i;
    end;

    for j := id[v] - 1 downto 1 do
    begin
      cur := q[j];
      nxt := q[j + 1];
      cnt[cur] := cnt[nxt] + 1;
    end;
  end;

  K := 1;
  for i := 1 to N do
  begin
    if cnt[i] > cnt[K] then
      K := i;
  end;

  WriteLn(K, ' ', cnt[K]);
end.
