program munkak;

uses
  SysUtils;

const
  MAXN = 100001;

var
  N, M, i, a, x, ans, cur: longInt;
  Hx, Hi, dpx, dpf: array[0..MAXN] of longInt;
  w: array of longInt;

begin
  ReadLn(N, M);

  for i := 0 to N do
  begin
    Hx[i] := 0;
    Hi[i] := 0;
  end;

  for i := 1 to M do
  begin
    ReadLn(a, x);
    if x > Hx[a] then
    begin
      Hx[a] := x;
      Hi[a] := i;
    end;
  end;

  dpx[0] := 0;
  dpf[0] := 0;
  dpx[1] := Hx[1];
  dpf[1] := 0;
  dpx[2] := Hx[2];
  dpf[2] := 0;

  for i := 3 to N do
  begin
    if dpx[i - 2] >= dpx[i - 3] then
    begin
      dpx[i] := dpx[i - 2] + Hx[i];
      dpf[i] := i - 2;
    end
    else
    begin
      dpx[i] := dpx[i - 3] + Hx[i];
      dpf[i] := i - 3;
    end;
  end;

  ans := 0;
  cur := 0;
  for i := 1 to N do
  begin
    if dpx[i] > ans then
    begin
      ans := dpx[i];
      cur := i;
    end;
  end;

  SetLength(w, 0);
  while cur > 0 do
  begin
    if Hi[cur] > 0 then
    begin
      SetLength(w, Length(w) + 1);
      w[High(w)] := Hi[cur];
    end;
    cur := dpf[cur];
  end;

  WriteLn(ans, ' ', Length(w));
  for i := High(w) downto 0 do
    Write(w[i], ' ');
  WriteLn;
end.
