using System;
using System.Collections.Generic;
using System.Linq;

class Csucs
{
    public int id;
    public List<Csucs> hova = new List<Csucs>();
    public Csucs ut;
    public int max = int.MinValue;
    public bool jart;
    public int latvanyossag;

    public void Bejar()
    {
        if (jart)
            return;
        jart = true;
        foreach (Csucs cs in hova)
        {
            cs.Bejar();
            if (cs.max > max)
            {
                max = cs.max;
                ut = cs;
            }
        }
        max += latvanyossag;
    }
}

static class Program
{
    static void Main()
    {
        string[] s0 = Console.ReadLine().Split();
        int N = int.Parse(s0[0]), M = int.Parse(s0[1]);
        var csucsok = Console.ReadLine().Split().Select(
            (x, i) => new Csucs { id = i + 1, latvanyossag = int.Parse(x) }).ToArray();
        for (int i = 0; i < M; i++)
        {
            string[] s1 = Console.ReadLine().Split();
            int u = int.Parse(s1[0]), v = int.Parse(s1[1]);
            csucsok[u - 1].hova.Add(csucsok[v - 1]);
        }
        csucsok[N - 1].max = csucsok[N - 1].latvanyossag;
        csucsok[N - 1].jart = true;
        csucsok[0].Bejar();
        if (csucsok[0].max < 0)
        {
            Console.WriteLine(-1);
            return;
        }
        Console.WriteLine(csucsok[0].max);
        Csucs cs = csucsok[0];
        while (cs != null)
        {
            Console.Write(cs.id + " ");
            cs = cs.ut;
        }
    }
}
