#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 100001;
int N, M;
pair<int,int> H[MAXN], dp[MAXN];

int main() {
    ios::sync_with_stdio(false);
    cin >> N >> M;
    for (int i = 1; i <= M; ++i) {
        int a, h;
        cin >> a >> h;
        H[a] = max(H[a], make_pair(h, i));
    }
    dp[1] = {H[1].first, 0};
    dp[2] = {H[2].first, 0};
    for (int i = 3; i <= N; ++i) {
        if (dp[i - 2].first >= dp[i - 3].first)
            dp[i] = {dp[i - 2].first + H[i].first, i - 2};
        else
            dp[i] = {dp[i - 3].first + H[i].first, i - 3};
    }
    int ans = 0, cur = 0;
    for (int i = 1; i <= N; ++i) {
        if (dp[i].first > ans)
            ans = dp[i].first, cur = i;
    }
    
    vector<int> w;
    while (cur > 0) {
        if (H[cur].second > 0)
            w.push_back(H[cur].second);
        cur = dp[cur].second;
    }
    cout << ans << " " << w.size() << endl;
    for (int id : w)
        cout << id << " ";
    cout << endl;

    return 0;
}
