#include <iostream>
#include <vector>
#include <stack>

using namespace std;

struct Graf{
    int latv, latv_eddig = 0, parent_cnt = 0, honnan = -1;
    vector<int> child;
    bool bfs = false;
};

int main() {
    int n, m;
    cin >> n >> m;

    vector<Graf> terek(n+1);
    for (int i=1;i<=n;i++){
        cin >> terek[i].latv;
    }
    for (int i=0;i<m;i++){
        int temp[2];
        cin >> temp[0] >> temp[1];
        terek[temp[0]].child.push_back(temp[1]);
    }

    //
    stack<int> bfs;
    bfs.push(1);
    while (!bfs.empty()){
        int curr=bfs.top();
        bfs.pop();
        for (int chl : terek[curr].child){
            terek[chl].parent_cnt++;
            if (!terek[chl].bfs){
                terek[chl].bfs = true;
                bfs.push(chl);
            }
        }
    }
    if (!terek[n].bfs){
        cout << -1 << endl;
        return 0;
    }

    //
    stack<int> dfs;
    dfs.push(1);
    while(!dfs.empty()){
        int curr = dfs.top(), latv = terek[curr].latv_eddig + terek[curr].latv;
        dfs.pop();
        for (int chl : terek[curr].child){
            if (terek[chl].latv_eddig < latv){
                terek[chl].latv_eddig = latv;
                terek[chl].honnan = curr;
            }
            terek[chl].parent_cnt--;
            if (0 == terek[chl].parent_cnt){
                dfs.push(chl);
            }
        }
    }

    cout << terek[n].latv + terek[n].latv_eddig << '\n';
    stack<int> sol;
    sol.push(n);
    while (1 != sol.top()){
        sol.push(terek[sol.top()].honnan);
    }
    bool f = true;
    while (!sol.empty()){
        if (!f)
            cout << ' ';
        cout << sol.top();
        sol.pop();
        f = false;
    }
    cout << endl;
    return 0;
}
