N, M = map(int, input().split())
P = [0] + list(map(int, input().split()))
adj = [list() for _ in range(N + 1)]
for _ in range(M):
    u, v = map(int, input().split())
    adj[u].append(v)

indeg = [0] * (N + 1)
q = [1]
for u in q:
    for v in adj[u]:
        if indeg[v] == 0:
            q.append(v)
        indeg[v] += 1

DP = P.copy()
par = [-1] * (N + 1)
q = [1]
for u in q:
    for v in adj[u]:
        indeg[v] -= 1
        if indeg[v] == 0:
            q.append(v)
        if DP[u] + P[v] > DP[v]:
            DP[v] = DP[u] + P[v]
            par[v] = u
if par[N] == -1:
    print(-1)
    exit(0)
path = [N]
while path[-1] != 1:
    path.append(par[path[-1]])

print(DP[N])
print(*path[::-1])
